-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}

local gear_A = 0
local gearIndex = 0

local function init()
    electrics.values.sft_rl = 0
    electrics.values.sft_fb = 0
	electrics.values.negsft_rl = -electrics.values.sft_rl
    electrics.values.negsft_fb = -electrics.values.sft_fb
end

local function reset()
  onInit()
end

local function updateGFX(dt)

  local sft_rl_leftside = -0.3      --LEFT MOUVEMENT
  local sft_rl_middle = 0			--MIDDLE RIGHT LEFT MOUVEMENT
  local sft_rl_rightside = 0.3      --RIGHT MOUVEMENT
  local sft_rl_reverseside = 0.6    --REVERSE MOUVEMENT
  local sft_fb_frontside = 0.3 		--FRONT MOUVEMENT
  local sft_fb_middle = 0			--MIDDLE FRONT BACK MOUVEMENT
  local sft_fb_backside = -0.3		--BACK MOUVEMENT
  
  
  gearIndex = electrics.values.gearIndex or 0
--Reverse Manual
  if gearIndex < -0.5 then
	electrics.values.sft_fb = sft_fb_backside
  end
  if gearIndex < -0.5 then
	electrics.values.sft_rl = sft_rl_reverseside
  end
--Neutral
  if gearIndex >= -0.5 and gearIndex < 0.5 then 	--FRONT BACK PART
	electrics.values.sft_fb = sft_fb_null
  end
  if gearIndex >= -0.5 and gearIndex < 0.5 then		--REAR LEFT PART
	electrics.values.sft_rl = sft_fb_null
  end
--First
  if gearIndex >= 0.5 and gearIndex < 1.5 then		--FRONT BACK PART
	electrics.values.sft_fb = sft_fb_frontside
  end
  if gearIndex >= 0.5 and gearIndex < 1.5 then		--REAR LEFT PART
	electrics.values.sft_rl = sft_rl_leftside
  end
--Second
  if gearIndex >= 1.5 and gearIndex < 2.5 then		--FRONT BACK PART
	electrics.values.sft_fb = sft_fb_backside
  end
  if gearIndex >= 1.5 and gearIndex < 2.5 then		--REAR LEFT PART
	electrics.values.sft_rl = sft_rl_leftside
  end
--Third
  if gearIndex >= 2.5 and gearIndex < 3.5 then
	electrics.values.sft_fb = sft_fb_frontside
  end
  if gearIndex >= 2.5 and gearIndex < 3.5 then
	electrics.values.sft_rl = sft_rl_middle
  end
--Fourth
  if gearIndex >= 3.5 and gearIndex < 4.5 then
	electrics.values.sft_fb = sft_fb_backside
  end
  if gearIndex >= 3.5 and gearIndex < 4.5 then
   electrics.values.sft_rl = sft_rl_middle
  end
--Fifth
  if gearIndex >= 4.5 and gearIndex < 5.5 then
	electrics.values.sft_fb = sft_fb_frontside
  end
  if gearIndex >= 4.5 and gearIndex < 5.5 then
	electrics.values.sft_rl = sft_rl_rightside
  end
--Sixth
  if gearIndex >= 5.5 and gearIndex < 6.5 then
	electrics.values.sft_fb = sft_fb_backside
  end
  if gearIndex >= 5.5 and gearIndex < 6.5 then
	electrics.values.sft_rl = sft_rl_rightside
  end
--Seventh
  if gearIndex >= 6.5 then
	electrics.values.sft_fb = sft_fb_frontside
  end
  if gearIndex >= 6.5 then
	electrics.values.sft_rl = sft_rl_reverseside
  end
end

-- public interface
M.onInit    = onInit
M.reset   = reset
M.updateGFX = updateGFX

return M